<?php
/*
 * Copyright 2012-2016 Damien Seguy – Exakat Ltd <contact(at)exakat.io>
 * This file is part of Exakat.
 *
 * Exakat is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Exakat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Exakat.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <http://exakat.io/>.
 *
*/


namespace Analyzer\Structures;

use Analyzer;

class DanglingArrayReferences extends Analyzer\Analyzer {
    public function analyze() {
        $this->atomIs('Foreach')
             ->outIs('VALUE')
             ->is('reference', true)
             ->savePropertyAs('code', 'array')
             ->back('first')
             ->nextSibling()
            // unset($x);
             ->raw('filter{ it.has("atom", "Functioncall").has("code", "unset").out("ARGUMENTS").out("ARGUMENT").filter{ it.code == array }.any() == false; }')
            // (unset) $x;
             ->raw('filter{ it.has("token", "T_UNSET_CAST").out("CAST").filter{ it.code == array }.any() == false; }')
             ->back('first');
        $this->prepareQuery();
    }
}

?>
